#include "at32f403a_407_board.h"
#include "at32f403a_407_clock.h"
#include "usb.h"
#include "usbd_core.h"
#include "msc_class.h"
#include "msc_desc.h"
#include "usbd_int.h"


usbd_core_type usb_core_dev;
extern usbd_class_handler usbd_rndis_cb;
extern void usb_clock48m_select(usb_clk48_s clk_s);


//
void usb_init(void)
{
    gpio_init_type gpio_initstructure;
    
    crm_periph_clock_enable(CRM_GPIOA_PERIPH_CLOCK, TRUE);
    
/*        
    gpio_initstructure.gpio_out_type       = GPIO_OUTPUT_PUSH_PULL;  
    gpio_initstructure.gpio_pull           = GPIO_PULL_NONE;  
    gpio_initstructure.gpio_mode           = GPIO_MODE_MUX;  
    gpio_initstructure.gpio_drive_strength = GPIO_DRIVE_STRENGTH_STRONGER;
    gpio_initstructure.gpio_pins           = GPIO_PINS_11 | GPIO_PINS_12;
    gpio_init(GPIOA, &gpio_initstructure); 
*/    
    
    //gpio_pin_mux_config(GPIOA, GPIO_PINS_SOURCE12, GPIO_MUX_10);
    //gpio_pin_mux_config(GPIOA, GPIO_PINS_SOURCE11, GPIO_MUX_10);
    
    //gpio_bits_reset(GPIOE, GPIO_PINS_9);
    
    
    nvic_irq_enable(USBFS_L_CAN1_RX0_IRQn, 0, 0);

    usbd_core_init(&usb_core_dev, USB, &msc_class_handler, &msc_desc_handler, 0);
    
    // enable usb pull-up
    usbd_connect(&usb_core_dev);
}


//
void USBFS_L_CAN1_RX0_IRQHandler(void)
{
    usbd_irq_handler(&usb_core_dev);
}


/**
  * @brief  usb delay millisecond function.
  * @param  ms: number of millisecond delay
  * @retval none
  */
void usb_delay_ms(uint32_t ms)
{
  /* user can define self delay function */
  delay_ms(ms);
}

/**
  * @brief  usb delay microsecond function.
  * @param  us: number of microsecond delay
  * @retval none
  */
void usb_delay_us(uint32_t us)
{
  delay_us(us);
}
